<?php
ob_start('ob_gzhandler');
error_reporting(0);
require_once 'Medoo.php';
require_once 'jdf.php';
include_once 'file.php';
$off_on_all = file_get_contents("/ReqFiles/onoff_filter.txt");
$off_on_H = file_get_contents("/ReqFiles/onoff_filterHamegani.txt");
$off_on_F = file_get_contents("/ReqFiles/onoff_filtersendfile.txt");
use Medoo\Medoo;
$db = new Medoo(['database_type' => 'mysql', 'database_name' => $config['database']['database_name'], 'server' => 'localhost', 'username' => $config['database']['username'], 'password' => $config['database']['password'], 'charset' => 'utf8mb4', 'collation' => 'utf8mb4_general_ci']);
define('API_KEY', $config['bot']['token']);
function request($method, $datas = [])
{
	$url = "https://api.telegram.org/bot" . API_KEY . "/" . $method;
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $datas);
	$res = curl_exec($ch);
	if (curl_error($ch)) {
		var_dump(curl_error($ch));
	} else {
		return json_decode($res);
	}
}
function DBconnect(){
	global $dbName,$dbUserName,$dbPassword;
	$connect = mysqli_connect('localhost',$dbUserName,$dbPassword,$dbName);
	mysqli_query($connect,"SET NAMES utf8mb4");
	return $connect;
}
function short_link($url)
{
	$curl = curl_init("https://vurl.com/api.php?url={$url}");
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	return $res = curl_exec($curl);
}
function convert($size)
{
	return round($size / pow(1024, $i = floor(log($size, 1024))), 2) . ' ' . ['', 'K', 'M', 'G', 'T', 'P'][$i] . 'B';
}
function document($name)
{
	if ($name == "document") {
		return "فایل";
	}
	if ($name == "video") {
		return "ویدیو";
	}
	if ($name == "photo") {
		return "عکس";
	}
	if ($name == "voice") {
		return "ویس";
	}
	if ($name == "audio") {
		return "موزیک";
	}
	if ($name == "sticker") {
		return "استیکر";
	}
}
function send($from_id, $text, $key = null, $msg = '', $markdown = 'html')
{
	return request('sendMessage', ['chat_id' => $from_id, 'text' => $text, 'reply_markup' => $key, 'reply_to_message_id' => $msg, 'parse_mode' => $markdown, 'disable_web_page_preview' => true]);
}
function sm($text, $key = null, $msg = '', $markdown = 'html')
{
	global $chat_id, $off_on_all;
	if($off_on_all == 'on'){
		$hiden = true;
	} else{
		$hiden = false;
	}
	return request('sendMessage', ['chat_id' => $chat_id, 'text' => $text, 'reply_markup' => $key, 'reply_to_message_id' => $msg, 'parse_mode' => $markdown, 'disable_web_page_preview' => true, 'disable_forward_messages' => true, 'protect_content' => $hiden]);
}
function IsJoin()
{
	global $from_id, $set, $sql;

	$explode = explode("|", $set['channel']);
	$getall = mysqli_query($sql,"SELECT * FROM channels WHERE type='member'");
	$check = mysqli_num_rows($getall);
	
	if($check >0){
		while($fetch = mysqli_fetch_assoc($getall)){
			
			$res = request('getChatMember', ['chat_id' => $fetch['id'], 'user_id' => $from_id])->result->status;
			if ($res == 'left') {
				return true;
			}
		}
	}
	$getall = mysqli_query($sql,"SELECT * FROM channels WHERE type='ejbarijoin'");
	$check = mysqli_num_rows($getall);
	if($check >0){
		while($fetch = mysqli_fetch_assoc($getall)){
			
			$res = request('getChatMember', ['chat_id' => $fetch['id'], 'user_id' => $from_id])->result->status;
			if ($res == 'left') {
				return true;
			}
		}
	}
	foreach ($explode as $channel) {
		$res = request('getChatMember', ['chat_id' => $channel, 'user_id' => $from_id])->result->status;
		if ($res == 'left') {
			return true;
		}
	}
}
function Isnonejoin()
{
	global $sql;
	$getall = mysqli_query($sql,"SELECT * FROM noneejbar");
	$check = mysqli_num_rows($getall);
	
if($check >0){
	return true;
}

}
function joinWarn($add)
{
	global $sql, $set, $from_id;
	$keyboard = [];
	$i = 1;
	$getall = mysqli_query($sql,"SELECT * FROM channels WHERE type='member'");
	$check = mysqli_num_rows($getall);
	
	if($check >0){
		while($fetch = mysqli_fetch_assoc($getall)){
			$res = request('getChatMember', ['chat_id' => $fetch['id'], 'user_id' => $from_id])->result->status;
			if ($res == 'left') {
			$keyboard[] = [['text' => 'عضویت در کانال ' . str_replace(range(1, 9), ['اول', 'دوم', 'سوم', 'چهارم', 'پنجم', 'ششم', 'هفتم', 'هشتم', 'نهم'], $i), 'url' => $fetch['link']]];
			$i++;
			}}
		}
	$getall = mysqli_query($sql,"SELECT * FROM channels WHERE type='ejbarijoin'");
	$check = mysqli_num_rows($getall);
	
	if($check >0){
		while($fetch = mysqli_fetch_assoc($getall)){
			$res = request('getChatMember', ['chat_id' => $fetch['id'], 'user_id' => $from_id])->result->status;
			if ($res == 'left') {
			$keyboard[] = [['text' => 'عضویت در کانال ' . str_replace(range(1, 9), ['اول', 'دوم', 'سوم', 'چهارم', 'پنجم', 'ششم', 'هفتم', 'هشتم', 'نهم'], $i), 'url' => $fetch['link']]];
			$i++;
			}}
		}

	$getall = mysqli_query($sql,"SELECT * FROM noneejbar");
	$check = mysqli_num_rows($getall);
	
	if($check >0){
		while($fetch = mysqli_fetch_assoc($getall)){
			
			$keyboard[] = [['text' => 'عضویت در کانال ' . str_replace(range(1, 9), ['اول', 'دوم', 'سوم', 'چهارم', 'پنجم', 'ششم', 'هفتم', 'هشتم', 'نهم'], $i), 'url' => $fetch['chanel']]];
			$i++;
			}
		}
	$notj = explode("|", $set['channel']);
	if($set['channel'] != NULL){
	foreach ($notj as $ch) {
		if (is_numeric($ch)) {
			$res = request('getchat', ['chat_id' => $ch]);
			$id = $res->result->invite_link;
		} else {
			$id = 'https://t.me/' . str_replace('@', null, $ch);
		}
		$keyboard[] = [['text' => 'عضویت در کانال ' . str_replace(range(1, 9), ['اول', 'دوم', 'سوم', 'چهارم', 'پنجم', 'ششم', 'هفتم', 'هشتم', 'نهم'], $i), 'url' => $id]];
		$i++;
	}
}
	$keyboard[] = $add;
	$key = json_encode(['inline_keyboard' => $keyboard]);
	sm("👇 لطفا در کانال های پایین عضو شوید و سپس بر روی دکمه عضو شدم کلیک کنید.", $key);
}
function GetMe($method, $token = API_KEY)
{
	return request('GetMe', [], $token)->result->{$method};
}
function editmessage($msg, $text, $key = null, $markdown = 'html', $ch = null)
{
	global $chat_id;
	if (isset($ch)) {
		$chat_id = $ch;
	}
	return request('editMessageText', ['chat_id' => $chat_id, 'text' => $text, 'reply_markup' => $key, 'message_id' => $msg, 'parse_mode' => $markdown]);
}
function editmessagee($msg, $text, $chat_id, $key = null, $markdown = 'html', $ch = null)
{
	if (isset($ch)) {
		$chat_id = $ch;
	}
	return request('editMessageText', ['chat_id' => $chat_id, 'text' => $text, 'reply_markup' => $key, 'message_id' => $msg, 'parse_mode' => $markdown]);
}
function del($message_id)
{
	global $chat_id;
	return request('deletemessage', ['chat_id' => $chat_id, 'message_id' => $message_id]);
}
function deltime($message_id,$chat_id)
{
	return request('deletemessage', ['chat_id' => $chat_id, 'message_id' => $message_id]);
}
function timesend()
{
	global $db;
	$sec = $db->count('users') * 60 / 700 / 60;
	$min = floor($sec);
	return $min;
}
function RandomString()
{
	$characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
	$randstring = null;
	for ($i = 0; $i < 5; $i++) {
		$randstring .= $characters[rand(0, strlen($characters))];
	}
	return $randstring;
}
function SendMessage($from_id,$text,$keyboard = null,$message = null){
	global $off_on_H, $off_on_all;
	if($off_on_H == 'on' or $off_on_all == 'on'){
		$hiden = true;
	}else{
		$hiden = false;
	}
	return request('sendMessage',[
	'chat_id' => $from_id,
	'text' => $text,
	'reply_markup' => $keyboard,
	'reply_to_message_id' => $message,
	'parse_mode' => 'html',
	'disable_web_page_preview' => true,
	'protect_content' => $hiden
	]);
}
function forwardmessage($tochatId, $fromchatId, $message_id){
	global $off_on_H, $off_on_all;
	if($off_on_H == 'on' or $off_on_all == 'on'){
		$hiden = true;
	}else{
		$hiden = false;
	}
    return request('forwardMessage',[
        'chat_id'=>$tochatId,
        'from_chat_id'=>$fromchatId,
        'message_id'=>$message_id,
		'protect_content' => $hiden
    ]);
}
function SendFile($chat_id,$type,$file_id,$caption = null,$key = null){
	global $off_on_H, $off_on_all;
	if($off_on_H == 'on' or $off_on_all == 'on'){
		$hiden = true;
	}else{
		$hiden = false;
	}
	return request("send$type",[
	'chat_id' => $chat_id,
	"$type" => $file_id,
	'caption' => $caption,
	'reply_markup' => $key,
	'parse_mode' => 'html',
	'protect_content' => $hiden
	]);
}
function getChat($chat_id){
    $result = file_get_contents("https://api.telegram.org/bot" . API_KEY . "/getchat?chat_id=$chat_id");
    return $result;
}
function lefttime($message_id){
	del($message_id);
    // sleep(3);
}
function rimovermassage($message_id){
	global $chat_id, $sql;
	$message_id = $message_id;
	$time = microtime(true);
	//if (mysqli_num_rows(mysqli_query($sql,"SELECT * FROM `rimover` ")) < 200) {
	mysqli_query($sql, "INSERT INTO `rimover` (`time`,`idchek`, `chatid`) VALUES ('$time','$message_id','$chat_id')");
	
	
//}
//else{
//mysqli_query($sql, "INSERT INTO `rimover2` (`time`,`idchek`, `chatid`) VALUES ('$time','$message_id','$chat_id')");
//}
}
function AnswerCallbackquery($chat_id,$text,$alert = false){
	request('answercallbackquery',[
	'callback_query_id' => $chat_id,
	'text' => $text,
	'show_alert' => $alert,
	'parse_mode' => 'html'
	]);
}
// -- {شروط افزایش سرعت ارسال} -- >> send message all - and number - <<
function allsppedsendmessage($type,$caption,$file_id,$message_id,$out_number){
    global $from_id, $time, $sql;
if($out_number <= 500){
	mysqli_query($sql,"INSERT INTO send_tbl (admin,start_time,type,text,file_id,message_id,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$out_number)");
	}else{
 		if(1000>=$out_number and $out_number>500){
 			$Rout_number = $out_number/2;
 			$rand = round($Rout_number); 
 			mysqli_query($sql,"INSERT INTO send_tbl (admin,start_time,type,text,file_id,message_id,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand)");
 			mysqli_query($sql,"INSERT INTO send_tbl1 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand+1,$out_number)");
 		}else{
 			if(5000>=$out_number and $out_number>1000){
 			$Rout_number = $out_number/3;
 			$rand = round($Rout_number);
 			mysqli_query($sql,"INSERT INTO send_tbl (admin,start_time,type,text,file_id,message_id,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand)");
 			mysqli_query($sql,"INSERT INTO send_tbl1 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand+1,$rand*2)");
 			mysqli_query($sql,"INSERT INTO send_tbl2 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*2+1,$rand*3)");
			}else{
                // باتمام سرعت
 				if($out_number>5000){
 				$Rout_number = $out_number/8;
 				$rand = round($Rout_number); 
 				mysqli_query($sql,"INSERT INTO send_tbl (admin,start_time,type,text,file_id,message_id,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand)");
				mysqli_query($sql,"INSERT INTO send_tbl1 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand+1,$rand*2)");
 				mysqli_query($sql,"INSERT INTO send_tbl2 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*2+1,$rand*3)");
 				mysqli_query($sql,"INSERT INTO send_tbl3 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*3+1,$rand*4)");
 				mysqli_query($sql,"INSERT INTO send_tbl4 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*4+1,$rand*5)");
				mysqli_query($sql,"INSERT INTO send_tbl5 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*5+1,$rand*6)");
 				mysqli_query($sql,"INSERT INTO send_tbl6 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*6+1,$rand*7)");
 				mysqli_query($sql,"INSERT INTO send_tbl7 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*7+1,$rand*8)");
 /*mysqli_query($sql,"INSERT INTO send_tbl8 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*8+1,$rand*9)");	
 			mysqli_query($sql,"INSERT INTO send_tbl9 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*9+1,$rand*10)");
 mysqli_query($sql,"INSERT INTO send_tbl10 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*10+1,$rand*11)");
 
	 mysqli_query($sql,"INSERT INTO send_tbl11 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*11+1,$rand*12)");	
	 
	  mysqli_query($sql,"INSERT INTO send_tbl12 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*12+1,$rand*13)");	
	  
	   mysqli_query($sql,"INSERT INTO send_tbl13 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*13+1,$rand*14)");	
	   
	    mysqli_query($sql,"INSERT INTO send_tbl14 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*14+1,$rand*15)");	
		
		 mysqli_query($sql,"INSERT INTO send_tbl15 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*15+1,$rand*16)");	
		 
		  mysqli_query($sql,"INSERT INTO send_tbl16 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*16+1,$rand*17)");	
		  
		   mysqli_query($sql,"INSERT INTO send_tbl17 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*17+1,$rand*18)");	
		   
		    mysqli_query($sql,"INSERT INTO send_tbl18 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*18+1,$rand*19)");	
 		
		 mysqli_query($sql,"INSERT INTO send_tbl19 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*19+1,$rand*20)");	
		 
// mysqli_query($sql,"INSERT INTO send_tbl7 (admin,start_time,type,text,file_id,message_id,start_number,out_number) VALUES ('$from_id','$time','$type','$caption','$file_id','$message_id',$rand*7+1,$rand*8)"); */				
                }
 		     }
        }
    }
}
 // -- {شروط افزایش سرعت ارسال} -- >> send message all - and number - <<
$date = jdate('Y/m/d');
$time = jdate('H:i:s');
$updates = file_get_contents("php://input");
if (isset($argv[1])) {
	if (trim($argv[1]) != "") {
		$updates = file_get_contents(trim($argv[1]));
		unlink(trim($argv[1]));
	}
}

$update = json_decode($updates);
if (isset($update->message)) {
	$message = $update->message ?? null;
	$text = $update->message->text ?? null;
	$chat_id = $update->message->chat->id ?? null;
	$from_id = $update->message->from->id ?? null;
	$message_id = $update->message->message_id ?? null;
	$user = $db->select('users', '*', ['user_id' => $from_id])[0];
	$set = $db->select('admin', '*')[0];
	$usertext = $db->select('users', '*', ['user_id' => $text])[0];
	$first_name = $update->message->from->first_name ?? null;
	$forward_from_name = $update->message->reply_to_message->forward_sender_name;
    $forward_from = $update->message->forward_from;
	$forward_from_chat = $update->message->forward_from_chat;
    $forward_from_id = $update->message->reply_to_message->forward_from->id;
	
	
	$photo = $update->message->photo;
	$caption = $update->message->caption;
	$document = $update->message->document;
	$video = $update->message->video;
	$voice = $update->message->voice;

} elseif (isset($update->callback_query)) {
	$data = $update->callback_query->data;
	$chat_id = $update->callback_query->message->chat->id;
	$from_id = $update->callback_query->from->id;
	$callback_id = $update->callback_query->id;
	$message_id = $update->callback_query->message->message_id;
	$set = $db->select('admin', '*')[0];
	$user = $db->select('users', '*', ['user_id' => $chat_id])[0];
}
